package cz.jzitnik;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Scanner;

import com.garmin.fit.*;

class CustomFitListener implements MesgListener {
    private List<Mesg> messages = new ArrayList<>();

    @Override
    public void onMesg(Mesg mesg) {
        messages.add(mesg);
    }

    public void modifyData() {

        DateTime latestTime = null;

        for (int i = 0; i < messages.size(); i++) {
            Mesg mesg = messages.get(i);
            
            if (mesg.getNum() == MesgNum.RECORD) {
                RecordMesg recordMesg = new RecordMesg(mesg);
                DateTime time = recordMesg.getTimestamp();
                
                if (latestTime == null || time.compareTo(latestTime) > 0) {
                    latestTime = time;
                }
            }
        }

        for (int i = 0; i < messages.size(); i++) {
            Mesg mesg = messages.get(i);
            if (mesg.getNum() == MesgNum.EVENT) {
                EventMesg eventMesg = new EventMesg(mesg);
                if (eventMesg.getEventType() == EventType.STOP_ALL) {
                    eventMesg.setTimestamp(latestTime);
                    messages.set(i, eventMesg);
                }
            }
        }
    }

    public List<Mesg> getMessages() {
        return messages;
    }
}
